<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
<#if sysrun.getPSDBDevInst()??>
    <#assign dbinst = sysrun.getPSDBDevInst()>

:: 脚本使用须知：该脚本用于将ibiz平台中最新的表结构与生产环境中的表结构（镜像）做差异比较，得出差异内容，将差异内容更新到生产环境中实现数据库同步。
:: 指令1： liquibase : tag   说明：用于在【databaseChangelog】表中标记更新前最后一次的更新点
:: 指令2： liquibase : futureRollbackSQL     说明：输出最后一次更新点以后的更新脚本对应的回滚脚本

echo begin

call mvn org.liquibase:liquibase-maven-plugin:3.6.3:update -Dliquibase.driver=org.h2.Driver   -Dliquibase.changeLogFile=src/main/resources/liquibase/h2_table.xml  -Dliquibase.url="jdbc:h2:~/h2/ibzdbmirror/${dbinst.getUserName()};MODE=ORACLE;INIT=runscript from 'src/main/resources/liquibase/config/init_h2.sql';"  -DdefaultSchemaName=${dbinst.getUserName()}  -Dliquibase.username=${dbinst.getUserName()}  -Dliquibase.dropFirst=true

call mvn  org.liquibase:liquibase-maven-plugin:3.6.3:update -Dliquibase.driver=org.h2.Driver   -Dliquibase.changeLogFile=src/main/resources/liquibase/master_table.xml  -Dliquibase.url="jdbc:h2:~/h2/last_db/${dbinst.getUserName()};MODE=ORACLE;INIT=runscript from 'src/main/resources/liquibase/config/init_h2.sql';" -DdefaultSchemaName=${dbinst.getUserName()}   -Dliquibase.username=${dbinst.getUserName()}  -Dliquibase.dropFirst=true

call mvn  org.liquibase:liquibase-maven-plugin:3.6.3:diff -Dliquibase.driver=org.h2.Driver  -Dliquibase.changeLogFile=src/main/resources/liquibase/empty.xml  -Dliquibase.diffChangeLogFile="src/main/resources/liquibase/changelog/%date:~0,4%%date:~5,2%%date:~8,2%%time:~0,2%%time:~3,2%%time:~6,2%_diff.xml"  -Dliquibase.url="jdbc:h2:~/h2/last_db/${dbinst.getUserName()};MODE=ORACLE;INIT=runscript from 'src/main/resources/liquibase/config/init_h2.sql';"     -Dliquibase.username=${dbinst.getUserName()}   -Dliquibase.referenceUrl="jdbc:h2:~/h2/ibzdbmirror/${dbinst.getUserName()};MODE=ORACLE;INIT=runscript from 'src/main/resources/liquibase/config/init_h2.sql';"    -Dliquibase.referenceUsername=${dbinst.getUserName()}    -Dliquibase.referenceDefaultSchemaName=${dbinst.getUserName()}     -Dliquibase.defaultSchemaName=${dbinst.getUserName()}  -Dliquibase.diffExcludeObjects="Index:.*,table:IBZFILE,IBZUSER,IBZDATAAUDIT"

echo done

pause

</#if>
